/*
* BDtoE_Form.java -- BigDecimal l E `ɕϊ
* @version $Revision: 1.10 $, $Date: 2003/05/12 10:24:55 $
* BigDecimal x 
* double "mant * 10^exp"
* Bigdecimal "bdMant * 10^exp"
* `ɕϊB
* C1.0<|mant|,|dbMant|<10.0
*/
import java.math.*;
import java.util.*;

/**
*BigDecimal l E `ɕϊ܂B
*/
public class BDtoE_Form {
    private int        exp;     // w
    private double     mant;    // (double)
    private BigDecimal bdMant;  // (BigDecimal)
    /**
    * wԂ܂B
    */
    public int exp()  { return exp; }
    /**
    *  double lŕԂ܂B
    */
    public double mant() { return mant; }
    /**
    *  BigDecimal lŕԂ܂Bʂ 0 ꍇ͐؂̂Ă܂B
    */
    public BigDecimal bdMant() { return bdMant; }

    /**
    *BigDecimal <i>x</i>  E ` <i>m</i> ~10<sup>e</sup>
    * (1.0  |<i>m</i>| &lt; 10.0) ɕϊ܂B
    *ʂ 0 ͐؂̂Ă܂B
    *@param x BigDecimal l^܂B
    */
    public BDtoE_Form(BigDecimal x) {
        if (x.signum() == 0) {
            exp = 0;    mant = 0.0;  bdMant = BDTools.ZERO; return;
        }
        exp = BDTools.getExp10(x);  mant = BDTools.mant;
        bdMant = x.movePointLeft(exp);
//      if (exp <= 0) return; // exp <=0 ł0tĂ邱ƂBeXgEvOQƁB
    /*
    * ʂ 0 ؂̂ĂB
    * |x| 傫Ƃɂ 10 ił̖ 0 ̌𓾂̂Ɍ\ԂB
    * 0 ̌𓾂ȕւȕ@ȂB
    * BigInteger  getLowestSetBit()  2^100 Ȃǂɂ͎gȂB
    */
    /* char[] s = bdMant.toString().toCharArray(); gĂxɕωȂB
       CϊɎԂĂB*/
        String s = bdMant.toString();
        int zeros = 0;  //  0 ̌

        for (int i = s.length() - 1; s.charAt(i) == '0' ; i--) zeros++;
        if (zeros == 0) return;

        int decLen = s.length() - zeros - 2;  // s.length() > 3, [+|-]x.y0
        if (mant < 0) decLen--; // '-' 
        // (decLen + 1)ʈȉ؂̂ĂB
        bdMant = bdMant.divide(BDTools.ONE, decLen, BigDecimal.ROUND_DOWN); // 1 ŊĂB
    }
    /**
    *eXgpvOłB
    */
    public static void main(String[] args) {
        int precision = 128, fac = 20000;

// |z| 傫Ƃɂ 10 ił̖ 0 ̌𓾂̂Ɍ\ԂB
        BigDecimal z = BDTools.random(precision);
        System.out.println("z = " + z.doubleValue() + " ~10^" + fac);
        z = z.movePointRight(fac);

        long start = System.currentTimeMillis();
        BDtoE_Form bdZ = new BDtoE_Form(z);
        long time = System.currentTimeMillis() - start;
        System.out.println(" BDtoE_Form(z);  : " + time + "(ms)");

        start = System.currentTimeMillis();
        String sz = z.toString();
        time = System.currentTimeMillis() - start;
        System.out.println(" z.toString();  : " + time + "(ms)");
        System.out.println("mant = " + bdZ.mant());
        System.out.println("exp = " + bdZ.exp());
        System.out.println("bdMant =\n" + bdZ.bdMant() + "\n");

        for (int i = -5; i <= 5; i++) {
            BigDecimal x = BDTools.random(precision);
            x = x.movePointRight(precision * i / 2);
            if ((i & 1) != 0) x = x.negate();
            BDtoE_Form bdX = new BDtoE_Form(x);
            System.out.println("x =\n" + x);
            System.out.println("mant = " + bdX.mant());
            System.out.println("exp = " + bdX.exp());
            System.out.println("bdMant =\n" + bdX.bdMant() + "\n");
        }

        System.out.println("---- Z̏ꍇ ----");
        BigDecimal y = new BigDecimal("0.12345");
        BDtoE_Form bdY = new BDtoE_Form(y);
        System.out.println("y = " + y);
        System.out.println("mant = " + bdY.mant());
        System.out.println("exp = " + bdY.exp());
        System.out.println("bdMant = " + bdY.bdMant());

        int k = 100;
        System.out.println("(y * 10^" + k + ")*10^(" + (-k) + ") ƂƑ0t܂");
        y = bdY.bdMant().movePointRight(100);
        System.out.println("y = bdMant * 10^" + k + " = " + y);
        y = y.movePointRight(-k);
        System.out.println("y * 10^(" + (-k) + ") = " + y);
        bdY = new BDtoE_Form(y);
        System.out.println("bdMant = " + bdY.bdMant());
    }
}
