/*
* BinarySplitE.java -- binary splitting method ɂ e ̌vZ
* @version $Revision: 1.3 $, $Date: 2003/05/12 10:24:55 $
*/
import java.math.*;

/**
*binary splitting @gĎRΐ̒ e  BigDecimal ŌvZ܂B<br>
*zgfȕ@gpĂ܂B
* @see BinarySplit1
* @see BinarySplitPi2
*/

public class BinarySplitE extends BinarySplit1 {
    BinarySplitE(int L, int f) { super(L, f); }

    public BigDecimal bsA(int k) { return BDTools.ONE; }
    public BigDecimal bsB(int k) { return BDTools.ONE; }
    public BigDecimal bsC(int k) { return BigDecimal.valueOf(k + 1); }
    public BigDecimal getValue() {
        set();  putTogether();
    // e - 1 = 1/1! + 1/2! + 1/3! + .... ܂Ă邩1B
        return getValue(false).add(BDTools.ONE); // class BinarySplit1  getValue()
    }

    public static void main(String[] args) {
        final int L = 1024;  // L = 2^p
        int f = (int)(L * Math.log(L / Math.E) / Math.log(10)) + 10;
        BinarySplitE e = new BinarySplitE(L, f);

        long start = System.currentTimeMillis();
        BigDecimal result = e.getValue();
        long time = System.currentTimeMillis() - start;

        System.out.println("----- vZICo͏ -----");
        System.out.print("e = ");
        start = System.currentTimeMillis();
        result = BDTools.roundOff(result, f);
        BDTools.precision = f;   BDTools.print(result, 10); // Ԃ
//        System.out.println(result); // 
        long outTime = System.currentTimeMillis() - start;
        System.out.println("o͎ : " + outTime + "(ms)");
        System.out.print("o͌ = " + BDTools.decNumber + ", f = " + f);
        System.out.print("  vZ : " + time + "(ms)");
        System.out.println("   : " + e.upTo());
/* // MultiPrecision.e() Ɣrꍇ͂𐶂B
        int fm = (int)(f * Math.log(10) / Math.log(MultiPrecision.RADIX));
        MultiPrecision m = new MultiPrecision(fm);
        start = System.currentTimeMillis();
        String ms = m.toString(m.e());  // ϊ܂
        time = System.currentTimeMillis() - start;
        BigDecimal me = new BigDecimal(ms), d;
        d = result.subtract(me);
        System.out.print("MultiPrecision.e() ̌vZ : " + time + "(ms)  ");
        System.out.println("diffrence = " + BDTools.toDoubleString(d));
*/
    }
}
