/*
* CommonElements.java -- ʂ̗vf
* @version $Revision: 1.5 $, $Date: 2003/03/13 14:24:30 $
*/

import java.util.Random;

/**
* ʂ̗vf\܂B
*/
public class CommonElements {
    private static final int INT_MAX = Integer.MAX_VALUE;
    /**
    * 3̐^z <code>a[], b[], c[]</code> ɋʂȗvf\܂B
    * @param na <code>a[]</code> ɓĂvf̌B<br>
    *C<code>a[]</code> ̗vf͐񂳂ĂāCna &lt; a.length łƂ܂B
    *<code>a[na]</code>͍ƗpiԐljɎgp܂B<br>
    * <code>nb, b[], nc, c[]</code> ɕtĂlłB
    */
    public static void listOfSorted(
            int na, int a[], int nb, int b[], int nc, int c[]) {
        int i = 0, j = 0, k = 0, t = a[0];

        a[na] = b[nb] = c[nc] = INT_MAX; /* Ԑl */
        while (t < INT_MAX) {
            while (b[j] < t) j++;
            while (c[k] < t) k++;
            if (t == b[j] && t == c[k]) System.out.print(" " + t);
            do {  i++;  } while (a[i] == t);
            t = a[i];
        }
        System.out.println();
    }
    /**
    * vfƂĉ\Ȓl 0  N ܂ł̐̏ꍇ flag g@łB
    */
    public static void listByFlag(
            int na, int a[], int nb, int b[], int nc, int c[], int N) {
        int flag[] = new int[N + 1]; // 0 ɏĂ

        for (int i = 0; i < na; i++) flag[a[i]] |= 1;
        for (int i = 0; i < nb; i++) flag[b[i]] |= 2;
        for (int i = 0; i < nc; i++) flag[c[i]] |= 4;
        for (int i = 0; i <= N; i++)
            if (flag[i] == 7) System.out.print(" " + i);
    }
///// ȉ̓eXgp /////
    static final NumberFormatter FMT3d = new NumberFormatter("3d");
    private static long seed = System.currentTimeMillis();
    private static void makeRandomArray(int n, int max, int a[]) {
        Random rand = new Random(seed++);

        for (int i = 0; i < n; i++) a[i] = rand.nextInt(max);
        for (int i = 0; i < n; i++) System.out.print(FMT3d.toString(a[i]));
        System.out.println();
    }
    private static void makeSortedArray(int n, int a[]) {
        Random rand = new Random(seed++);

        a[0] = rand.nextInt(INT_MAX) / (INT_MAX / 5);
        for (int i = 1; i < n; i++)
            a[i] = a[i - 1] + rand.nextInt(INT_MAX) / (INT_MAX / 3);
        for (int i = 0; i < n; i++) System.out.print(FMT3d.toString(a[i]));
        System.out.println();
    }
    /**
    * eXgp
    */
    public static void main(String[] args) {
        final int L = 15, M = 20, N = 25;
        int a[] = new int[L + 1];
        int b[] = new int[M + 1];
        int c[] = new int[N + 1];

        System.out.println("---- by use of sort ---- ");
        System.out.print("a:");  makeSortedArray(L, a);
        System.out.print("b:");  makeSortedArray(M, b);
        System.out.print("c:");  makeSortedArray(N, c);
        System.out.print("common elements: ");
        listOfSorted(L, a, M, b, N, c);

        final int R = 20;
        System.out.println("\n---- by use of flag ---- ");
        System.out.print("a:");  makeRandomArray(L, R, a);
        System.out.print("b:");  makeRandomArray(M, R, b);
        System.out.print("c:");  makeRandomArray(N, R, c);
        System.out.print("common elements: ");
        listByFlag(L, a, M, b, N, c, R);
    }
}
