/*
* GCDandLCM.java -- ő񐔂 J. Stein ̕@ŋ߂B
* QigcdASY
* @version $Revision: 1.5 $, $Date: 2002/12/16 01:03:24 $
*/

/**
* ő񐔂 J. Stein ̕@iQigcdASYjŋ߂܂B
* @see GCD
*/
public class GCDandLCM {
    /**
    * Q̎R̍ő񐔂QigcdASYŋ߂܂B
    * @param u R
    * @param v R
    * @return <code>gcd(u,v)</code>
    */
    public static long gcd(long u, long v) {
        if (u <= 0 || v <= 0) throw new Error("G[ : gcd(u,v)");
        if (u == 1 || v == 1) return 1;
        long d = 1, t;
        while ((u % 2) == 0 && (v % 2) == 0) { // u, v ǂ炩ɂȂ܂2ŊB
            d *= 2;  u /= 2;  v /= 2; // d ɏLĂ
        }
        if ((u % 2) != 0) t = -v;
        else              t = u;
        while (t != 0) {
            while ((Math.abs(t) % 2) == 0) t /= 2;
            if (t > 0) u =  t;
            else       v = -t;
            t = u - v;
        }
        return u * d;
    }

    /**
    * Q̎R̍ŏ{߂܂B
    * @param a R
    * @param b R
    * @return <code>lcm(a,b)</code>
    */ 
    public static long lcm(long a, long b) {
        // łӂh~邽߂ɑ傫ɊB
        return a > b ? (a / gcd(a, b)) * b : a * (b / gcd(a, b));
    }
/**
* eXgpłB
*/
    public static void main(String[] args) {
        long a = 40902, b = 24140;

        System.out.println("GCD(" + a + "," + b + ") = " + gcd(a, b)); // 34 ɂȂ͂
        System.out.println("LCM(" + a + "," + b + ") = " + lcm(a, b));
    }
}
