/*
* Gauss3.java -- 3dΊpȘA
* @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:31 $
* class RVector gB
*/
import java.io.*;

/**
* 3dΊpȘA Gauss @ŉ܂B
*@see GaussElimination
*@see GaussSeidel
*@see Gauss5
*/
public class Gauss3 {
    static void solve(double[] diag,
            double[] sub, double[] sup, double[] b) {
        int n = diag.length;

        for (int i = 0; i < n - 1; i++) {  // @
            double t = sub[i] / diag[i];
            diag[i + 1] -= t * sup[i];
            b   [i + 1] -= t * b  [i];
        }
        b[n - 1] /= diag[n - 1];       // ޑ
        for (int i = n - 2; i >= 0; i--)
            b[i] = (b[i] - sup[i] * b[i + 1]) / diag[i];
    }

    /**
    * vOłB
    *<b>&quot;n =&quot;</b> ƕĂ܂ 2 ȏ̐l͂ĂB
    *\ׂ͂ 1.0 ɂȂ܂B
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        if (n < 2) System.exit(-1);

        double[] diag = new double[n], sub = new double[n],
                 sup  = new double[n], b   = new double[n];
        // .  ׂ͂ 1
        for (int i = 0; i < n; i++) {
            diag[i] = 4;  sub[i] = 1;  sup[i] = 2;  b[i] = 7;
        }
        b[0] = 6;  b[n - 1] = 5;
        solve(diag, sub, sup, b);
        RVector.print(b, 8, "9.6f");
        System.out.println("ׂ͂ 1");
    }
}
