/**
 *  EX
 *
 *  @version $Revision: 1.22 $, $Date: 2003/04/28 23:23:16 $
 */

import java.text.*;
import java.io.*;

/**
 * 1582/10/ 4 ȑOEXiAEOXgDX̉ɂj
 * 1582/10/15 ȍ~OSIŌvZB
 * I4NO͗jƂ͈vȂB
 * IO100N̏ꍇ-99NƂĈB
 */
public class JulianDay {
    public int year, month, day, hour, minute;
    public double second;

    public JulianDay(int    jd) {  toDate(jd);  }
    public JulianDay(double jd) {  toDate(jd);  }

    /** 烆EXɕϊ */
    public static int toNumber(int year, int month, int day) {
        if (month <= 2) { month += 12;  year--; }
        if ((year * 12 + month) * 31 + day >=
            (1582 * 12 + 10   ) * 31 + 15)  // 1582/10/15 ȍ~
            day += 2 - year / 100 + year / 400;  // OSI
        return (int)Math.floor(365.25 * (year + 4716)) +
            (int)(30.6001 * (month + 1)) + day - 1524;
    }

    /** 烆EXɕϊ */
    public static double toNumber(int year, int month, int day,
                                int hour, int minute, double second) {
        return toNumber(year, month, day) - 0.5 +
            (hour + (minute + second / 60.0) / 60) / 24;
    }

    /** EXɕϊ */
    public JulianDay toDate(int jd) {
        if (jd >= 2299161) {  // 1582/10/15 ȍ~̓OSI
            int t = (int)((jd - 1867216.25) / 365.2425);
            jd += 1 + t / 100 - t / 400;
        }
        jd += 1524;
        int y = (int)Math.floor((jd - 122.1) / 365.25);
        jd -= (int)Math.floor(365.25 * y);
        int m = (int)(jd / 30.6001);
        jd -= (int)(30.6001 * m);
        day = jd;  month = m -1;  year = y - 4716;
        if (month > 12) { month -= 12;  year++; }
        return this;
    }

    /** EXɕϊ */
    public JulianDay toDate(double jd) {
        jd += 0.5;  int i = (int)Math.floor(jd);  toDate(i);
        jd = (jd - i)      * 24;  hour   = (int)jd;
        jd = (jd - hour)   * 60;  minute = (int)jd;
        jd = (jd - minute) * 60;  second = jd;
        return this;
    }

    final static DecimalFormat df1 = new DecimalFormat(" 0000;-");
    final static DecimalFormat df2 = new DecimalFormat("00");
    final static DecimalFormat df3 = new DecimalFormat("00.000");
    public String toString() {
        return df1.format(year) + "/" + df2.format(month) + "/" +
            df2.format(day) + " " + df2.format(hour) + ":" +
            df2.format(minute) + ":" + df3.format(second);
    }

    public static void main(String[] args) throws IOException {
        BufferedReader input =
            new BufferedReader(new InputStreamReader(System.in));
        System.out.print("NH");
        int year = Integer.parseInt(input.readLine());
        System.out.print("H");
        int month = Integer.parseInt(input.readLine());        
        System.out.print("H");
        int day = Integer.parseInt(input.readLine());        
        System.out.print("H");
        int offset = Integer.parseInt(input.readLine());        
        JulianDay jd = new
            JulianDay(JulianDay.toNumber(year, month, day) + offset);
        System.out.println(jd.year + "N" + jd.month + ""
                           + jd.day + "łD");
    }
}
