/*
* MachineEpsilon.java -- @BGvV
* @version $Revision: 1.5 $, $Date: 2003/01/26 05:45:34 $
*/
import java.text.*; // DecimalFormat gB

/**
* @BGvV̎vOłB
*/
public class MachineEpsilon {
    static void doubleVersion() {
        final DecimalFormat DF = new DecimalFormat(" 0.0000000000000000E00");
        System.out.println("-------------------------- double version -------------------------------");
        System.out.println("    e                       1 + e                   (1 + e) - 1");
        System.out.println("------------------------- ----------------------- -----------------------");

        double e = 1, w = 1 + e;
        while (w > 1) {
            System.out.println(DF.format(e) + " " + DF.format(w) +
                " " + DF.format(w - 1));
            e /= 2;  w = 1 + e;
        }
    }

    static void floatVersion() {
        final DecimalFormat DF = new DecimalFormat(" 0.00000000E00");
        System.out.println("----------------- float version -----------------");
        System.out.println(" e                1 + e           (1 + e) - 1");
        System.out.println("---------------- ---------------- ---------------");

        float e = 1, w = 1 + e;
        while (w > 1) {
            System.out.println(DF.format(e) + " " + DF.format(w) +
                " " + DF.format(w - 1));
            e /= 2;  w = 1 + e;
        }
    }
    /**
    * Ȃ̏n̋@BGvV]܂B<br>
    * double  float o[W܂B
    *<blockquote><pre>
    * yQlz@BGvViC float.h̒lj
    * #define FLT_EPSILON         1.19209290E-07F               // float
    * #define DBL_EPSILON         2.2204460492503131E-16        // double
    * #define LDBL_EPSILON        1.084202172485504434e-019L    // long double
    *</pre></blockquote>
    */
    public static void main(String[] args) {
        doubleVersion();    floatVersion();
    }
}
