/**
 *  f
 *
 *  @version $Revision: 1.4 $, $Date: 2003/04/28 23:23:18 $
 */

public class Primes {
    static int[] generatePrimes(final int n) {  // {\tt n} ̑f𐶐
        int k = 0,  prime[] = new int[n];
        prime[k++] = 2;
        for (int x = 3; k < n; x += 2) {
            int i = 0;
            while (i < k && x % prime[i] != 0) i++;
            if (i == k) prime[k++] = x;
        }
        return prime;
    }

    public static void main(String[] args) {
        final int N = 168;
        int[] prime = generatePrimes(N);

        System.out.print("f\");
        for (int i = 0; i < N; i++) {
            if (i % 10 == 0) System.out.println();
            String s = "    " + prime[i];
            System.out.print(s.substring(s.length() - 5));
        }
        System.out.println();
    }
}
