/*
* RoundOff.java -- ľܓ
* @version $Revision: 1.5 $, $Date: 2003/03/13 14:24:36 $
*/
import java.io.*;

/**
* ľܓ̃vOłB
*/

public class RoundOff {
    static int round1000(int a, int b){ // $0 \le a \le b$, $b \ne 0$
        int d;

        if (a <= Integer.MAX_VALUE / 2000) { // Integer.MAX_VALUE = 2^31 - 1 = 2147483647
            d = a * 2000 / b;
        } else {
            int bl = b % 2000, bh = b / 2000;
            d = a / bh;
            int rp = (a % bh) * 2000, rm = bl * d;
            if (rp < rm) {
                d--;  rm -= rp;
                while (rm > b) {  d--;  rm -= b;  }
            }
        }
        return (d + 1) / 2;
    }
    /**
    *ɕϊ܂B
    *&quot;<strong>a =</strong>&quot;C&quot;<strong>b =</strong>&quot; ƕĂ܂B
    * <strong>a &lt; b &lt; 2147483647</strong> 𖞂R͂ƁCa/b 
    *Q̕@ŏ4ʂŎľܓʂ\܂B<br>
    *1000 * a ӂNꍇ͂Q̌ʂ͈قȂ܂B<br>
    *<b></b> <code>a = 12458978, b = 21245879</code>
    */
    public static void main(String[] args) throws IOException {
        BufferedReader input =
            new BufferedReader(new InputStreamReader(System.in));
        NumberFormatter fmt03d = new NumberFormatter("03d");

        System.out.print("a = ");
        int a = Integer.parseInt(input.readLine());
        System.out.print("b = ");
        int b = Integer.parseInt(input.readLine());
        int r = round1000(a, b);

        System.out.println("a / b = " + (r / 1000) + "." + fmt03d.toString(r % 1000));
        r = (1000 * a + b / 2) / b; // 1000 * a Ōӂ̉\
        System.out.println("a / b = " + (r / 1000) + "." + fmt03d.toString(r % 1000));
        System.out.println("a / b = " + (double)a/b + " (double value)");
    }
}
