/*
* SInteger.java -- {NX
* @version $Revision: 1.7 $, $Date: 2003/04/01 12:35:49 $
*/
import java.math.*;
import java.util.*;

/**
* 10,000̑{NXłB
* FFT Z̃eXgEvOpłāCKvŏ̋@\Ă܂B
*/

public class SInteger {
    static final int FIGURES  = 4;
    /**
    * (= 10,000)ێĂ܂B
    */
    public static final short RADIX = 10000; //  10^FIGURES
    /**
    *  BigInteger \ێĂ܂B
    */
    public static final BigInteger BI_RADIX = BigInteger.valueOf(RADIX);
    /**
    * eێĂ܂Bf[i] < RADIX łB
    */
    public short[] f;   // static ɂĂ͂ȂB
    /**
    * 10,000ł̌ێĂ܂B
    * <code>size = 2<sup>n</sup></code>łB
    */
    public int size;    //  size = 2^n ɂƂ

    static int ceilpow2(int sz) { // sz <= k = 2^n 𖞂ŏ k ԂBsz <= 0 ̏ꍇ0ԂB
        if (sz < 2) return sz > 0 ? 1 : 0;
        int k = 2;

        while (k < sz) k *= 2;
        return k;
    }
    /**
    * @param size 10,000ł̌^܂B
    * <code>size = 2<sup>n</sup></code> ɂȂ悤ɒ܂B
    */
    public SInteger(int size) {
        f = new short[this.size = ceilpow2(size)];
    }
    /**
    * SInteger  BigInteger ϊ񋟂܂B
    */
    public BigInteger toBigInteger() {
        int i = size - 1;
        while (f[i] == 0 && i >=0) i--;
        if (i < 0) i = 0;
        BigInteger biVal = BigInteger.valueOf(f[i--]); // ŏʂ̌

        for (; i >= 0; i--) { // Horner @ŌvZ
            biVal = biVal.multiply(BI_RADIX);
            biVal = biVal.add(BigInteger.valueOf(f[i]));
        }
        return biVal;
    }
    /**
    * SInteger \̂܂܏o͂܂B
    */
    public void print() {
        NumberFormatter fmt04d = new NumberFormatter("04d");
        NumberFormatter fmt4d  = new NumberFormatter("4d");
        int i = size - 1;
        while (f[i] == 0) {
            i--;
            if (i < 0) { System.out.println("0");    return; }
        }
        System.out.print(fmt4d.toString(f[i--]) + " "); // ŏʂ̌
        for (; i >= 0; i--) System.out.print(fmt04d.toString(f[i]) + ' ');
        System.out.println();
    }
    /**
    * SInteger IuWFNg size ̗Zbg܂B
    */
    public void setRandom(int size) {
        int cs = ceilpow2(size);
        if (this.size != cs) f = new short[this.size = cs];
        for (int i = 0; i < size; i++) f[i] = (short)(Math.random() * RADIX); // f[i] < RADIX
    }
}
