import java.io.*;

/**
 *  ϗʃf[^Ǎ݊֌W[`W
 *
 *  @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:36 $
 */
public class StatData {
    /**
     *  Ǎ݃G[ɓO
     */
    public class ReadError extends RuntimeException {}

    private Reader input;
    private StreamTokenizer in;
    private int nRows, nCols;

    /**
     *  f[^t@Cǂނ߂ɊJCŏɂ͂̌ nC
     *  ϗʂ̐ m ǂݍށB
     *
     *  @param  filename    f[^t@C
     *  @throw #ReadError
     *  @throw #MissingData
     */
    public StatData(String filename) {
        try {
            input = new FileReader(filename);
        } catch (FileNotFoundException e) { throw new ReadError(); }
        in = new StreamTokenizer(input);
        double x = getNum(), y = getNum();
        if (x <= 0 || x > Integer.MAX_VALUE ||
            y <= 0 || y > Integer.MAX_VALUE) {
            System.err.println("sE񐔂ǂݍ߂܂B");
            close(); throw new ReadError();
        }
        nRows = (int)x; nCols = (int)y;
        System.err.println(nRows + " s "
                         + nCols + " ̃f[^łB");
    }
    /**
     *  f[^t@C̓Ǎ݂IB
     */
    public void close() { try { input.close(); } catch (Exception e) {} }
    /**
     *  ԂB
     *
     *  @return 
     */
    public int numberOfRows() { return nRows; }
    /**
     *  ϗʂ̐ԂB
     *
     *  @return 
     */
    public int numberOfColumns() { return nCols; }
    /**
     *  f[^t@CP̃f[^ǂݍ݁C̒lԂB
     *
     *  @return ǂݍ񂾒l
     *  @throw #ReadError
     */
    public double getNum() {
        try {
            for (;;) {
                int ttype = in.nextToken();
                if (ttype == in.TT_EOF) { // t@CI[
                    close(); throw new ReadError();
                } else if (ttype == in.TT_NUMBER) { // l
                    return in.nval;
                } else if (ttype == '*') { // l
                    return Double.NaN;
                }
            }
        } catch (IOException e) { throw new ReadError(); }
    }
    /**
     *  f[^t@Cf[^ǂݍ񂾂̂sƂĕԂB
     *
     *  @return ǂݍ񂾒l
     *  @throw #ReadError
     */
    public double[][] readData() {
        double[][] m = new double[nCols][nRows];
        for (int i = 0; i < nRows; i++)
            for (int j = 0; j < nCols; j++)
                m[j][i] = getNum();
        close();
        return m;
    }
    /**
     *  f[^t@Cf[^ǂݍ񂾂̂sƂĕԂB
     *
     *  @param  filename    f[^t@C
     *  @return ǂݍ񂾒l
     *  @throw #ReadError
     */
    public static double[][] readData(String filename) {
        return new StatData(filename).readData();
    }
}

