/**
* StringMatch.java -- ƍ
* @version $Revision: 1.1 $, $Date: 2003/03/20 03:05:53 $
*/
/**
*ƍ̃vOłB
*@see KMP
*@see BoyerMoore
*/
public class StringMatch {
    // Java ł char[] ̍Ō '\0' Ƃ͌ȂB
    /**
    *text ̒ pattern ̂ʒuT܂B
    *@param text 
    *@param pattern T
    *@return pattern ̂ʒuB擪 0B
    *pattern Ȃꍇ -1B
    */
    public static int position1(char[] text, char[] pattern) {
        int i = 0, c = pattern[0], n = pattern.length;

        while (i < text.length) {
            if (text[i++] == c) {
                int k = i, j = 1;
                while (j < n && text[k] == pattern[j]) {
                    k++;  j++;
                }
                if (j == n) return k - j;  /*  */
            }
        }
        return -1;  /* Ȃ */
    }

   //***** 邢͓Ƃł邪... *****
    /**
    *position1() ƓlłB
    */
    public static int position2(char[] text, char[] pattern) {
        int i = 0, j = 0, n = pattern.length;

        while (i < text.length && j < n)
            if (text[i] == pattern[j]) {  i++;  j++;  }
            else {  i = i - j + 1;  j = 0;  }
        if (j == n) return i - j;  /*  */
        return -1;  /* Ȃ */
    }
    /**
    *<code>text = "AAAAAABAAAC", pattern[] = { "AAA", "AAB", "AAC", "AAD" }</code> ̏ꍇ
    *vOłB
    */

    public static void main(String[] args) {
        String text = "AAAAAABAAAC";
        String[] pattern = { "AAA", "AAB", "AAC", "AAD" };
        int n = pattern.length;

        for (int i = 0; i < n; i++)
            System.out.println("position1(\"" + text + "\", \"" + pattern[i] + "\") = "
                + position1(text.toCharArray(), pattern[i].toCharArray()));
        System.out.println();
        for (int i = 0; i < n; i++)
            System.out.println("position2(\"" + text + "\", \"" + pattern[i] + "\") = "
                + position2(text.toCharArray(), pattern[i].toCharArray()));
    }
}
