/**
* UKanji.java -- VtgJISEUCɕϊ
*  @version $Revision: 1.1 $, $Date: 2003/04/04 11:18:23 $
*
* java UKanji < infile > outfile
*
* ̂悤ɎgB
* CpJ^JiĂƁC͕̕B
*
* WindowsȂǂ"\r\n"̃yAUNIXn'\n'ɕϊ悤ɂĂB
*/

import java.io.*;

/**
* Vtg JIS ̃t@C EUC ̂̂ɕϊ܂B<br>
* Windows Ȃǂ &quot;\r\n&quot; ̃yA UNIX n '\n' ɕϊ܂B<br>
* gp@F<code>java UKanji &lt; infile &gt; outfile</code>
* @see SJIStoEUC
*/

public class UKanji {
    static boolean isKanji(int c) { // VtgJIS 1oCg
        return ((char)((c ^ 0x20) - 0xA1) <= 0x3B); // {Q
//        return (c >= 0x81 && c <= 0x9F) || (c >= 0xE0 && c <= 0xFC);
    }
    static boolean isKanji2(int c) { // VtgJIS 2oCg
        return c >= 0x40 && c <= 0xFC && c != 0x7F;
    }

    static int shiftJIStoJIS(int hi, int lo) { // VtgJISJIS
        if (hi <= 0x9F) {
            if (lo < 0x9F)  hi = (hi << 1) - 0xE1;
            else            hi = (hi << 1) - 0xE0;
        } else {
            if (lo < 0x9F)  hi = (hi << 1) - 0x161;
            else            hi = (hi << 1) - 0x160;
        }
        if      (lo < 0x7F) lo -= 0x1F;
        else if (lo < 0x9F) lo -= 0x20;
        else                lo -= 0x7E;

        return (hi << 8)| lo;
    }

    public static void main(String[] args) throws IOException {
        int c;

        while ((c = System.in.read()) != -1) {  // 1oCgǂݍ
            if (isKanji(c)) {
                int d = System.in.read();
                if (isKanji2(d)) {
                    int e = shiftJIStoJIS(c, d);  // c : ʁCd : ʃoCg
                    System.out.write((e >> 8)| 0x80);  // EUC ɕϊ1oCgo
                    System.out.write((e & 0xFF)| 0x80);
                } else {
                    System.out.write(c);
                    if (d != -1) System.out.write(d);
                }
            } else if (c == '\r');  // Ȃ
            else System.out.write(c);
        }
    }
}
