/**
* BinarySplit1.java -- binary splitting method ۃNX
* zgfȕ@B
* ċAĂяoł BinarySplit2.javaB
* BDTools.javaiBigDecimal WjgpĂB
* @version $Revision: 1.1 $, $Date: 2003/03/20 02:30:36 $
*/

import java.math.*;  // BigDecimal NXgB

/**
* binary splitting @̒ۃNX(abstract class)łB
* zgfȕ@łB<br>
* <b>gp@</b><br>
* {@link #bsA}ȂǂA<sub>k</sub>, B<sub>k</sub>, C<sub>k</sub>āC<br>
* PD{@link #set}<br>
* QD{@link #putTogether}<br>
* RD{@link #getValue}<br>
*̏ɌĂяoĂBeXebv̏Ԃvꍇ邽߁CĂ܂B
* @see BDTools
* @see BinarySplitE
* @see BinarySplit2
* @see BinarySplitPi2
*/
public abstract class BinarySplit1 {
/////// {ƏƂ炵킹ēǂ݂₷悤 L,N,A,B,C ͑啶gĂB ///////
    private int L;  //  L = 2^p ł邱ƁB
    private int N;
    BigDecimal[] A, B, C;
    BigDecimal result;
    static int ceilpow2(int sz) { // sz <= k = 2^n 𖞂ŏ k ԂBsz <= 0 ̏ꍇ0ԂB
        if (sz < 2) return sz > 0 ? 1 : 0;
        int k = 2;

        while (k < sz) k *= 2;
        return k;
    }
    /**
    * 10 ił̐xiLjԂ܂B
    */
    public int N() { return N; }
    /**
    * ۂ̍Ԃ܂B
    */
    public int upTo() { return L; }
    /**
    * [U <code>BinarySplitE(int nCint f) { super(n, f); }</code> ̂悤ȃRXgN^
    * Kv܂B
    * @see BinarySplitE
    * @param upto ̍w肵܂Bupto = 2<sup><i>n</i></sup> ɂȂ悤ɒ܂B
    * @param N Lw肵܂B
    */
    public BinarySplit1(int upto, int N) {
        L = ceilpow2(upto); // {ł ceilpow2() ͎gĂȂB
        this.N = N;
        A = new BigDecimal[L];  B = new BigDecimal[L];  C = new BigDecimal[L];
    }
    /**
    * A<sub>k</sub> Ԃۃ\bhłB<br>
    * [UI[o[ChKv܂B
    */
    public abstract BigDecimal bsA(int k);
    /**
    * B<sub>k</sub> Ԃۃ\bhłB<br>
    * [UI[o[ChKv܂B
    */
    public abstract BigDecimal bsB(int k);
    /**
    * C<sub>k</sub> Ԃۃ\bhłB<br>
    * [UI[o[ChKv܂B
    */
    public abstract BigDecimal bsC(int k);

    /**
    * <code>A[0..L-1], B[0..L-1], C[0..L-1]</code> Zbg܂B
    */
    public void set() {
        for (int i = 0; i < L; i++){
            A[i] = bsA(i);  B[i] = bsB(i);  C[i] = bsC(i);
        }
    }

    /**
    * Ws܂B
    */

    public void putTogether() {
        int n = L / 2;
        while (n != 0){
            for (int k = 0; k < n; k++){
                BigDecimal p = BDMult.bdMult(A[2 * k], C[2 * k + 1], N);

                A[k] = p.add(BDMult.bdMult(B[2 * k], A[2 * k + 1], N));
                B[k] = BDMult.bdMult(B[2 * k], B[2 * k + 1], N);
                C[k] = BDMult.bdMult(C[2 * k], C[2 * k + 1], N);
            }
            n /= 2;
        }
    }
    /**
    * ̘a BigDecimal ŕԂ܂B
    * @param inv <code>C[0]/A[0]</code>𓾂ꍇɂ <code>true</code> C
    *<code>A[0]/C[0]</code> ̏ꍇ <code>false</code> ^܂B
    */
    public BigDecimal getValue(boolean inv) {
        if (inv) result = C[0].divide(A[0], N, BigDecimal.ROUND_HALF_EVEN); // C[0]/A[0]
        else     result = A[0].divide(C[0], N, BigDecimal.ROUND_HALF_EVEN); // A[0]/C[0]

        return result;
    }
}
