/**
 * BitOutputStream.java -- rbgo̓Xg[
 *
 * @version $Revision: 1.7 $, $Date: 2003/03/22 02:31:14 $
 */

import java.io.*;
/**
* Huffman@ȂǂŎgrbgo̓[`łB
* @see BitInputStream
* @see Huffman
* @see Slide
* @see Squeeze
*/
public class BitOutputStream extends FilterOutputStream {
    public static final int MAX_BITS = 31;  // ݉\ȍőrbg
    protected int putCount = 8; // rbgo̓JE^
    protected int bitBuf = 0;   // rbgo̓obt@
    protected int outCount = 0; // oCgo̓JE^
    /**
    * RXgN^
    * @param out o̓Xg[
    */
    public BitOutputStream(OutputStream out) {  super(out);  }
    /**
    * o̓oCgԂ
    */
    public int outCount() {  return outCount;  }
    /**
     * x ̉E n rbgԂ
     */
    private static int rightBits(int n, int x) {
         return x & ((1 << n) - 1);
    }
    /**
    * 1rbgo
    */
    public void putBit(boolean bit) throws IOException {
        putCount--;
        if (bit) bitBuf |= (1 << putCount);
        if (putCount == 0) {
            out.write(bitBuf);
            bitBuf = 0;  putCount = 8;  outCount++;
        }
    }
    /**
    * x ̉E n rbgo
    */
    public void putBits(int n, int x) throws IOException {
        while (n >= putCount) {
            n -= putCount;
            bitBuf |= rightBits(putCount, x >>> n);
            out.write(bitBuf);
            bitBuf = 0;  putCount = 8;  outCount++;
        }
        putCount -= n;
        bitBuf |= rightBits(n, x) << putCount;
    }
    /**
    * Xg[N[Y
    */
    public void close() throws IOException {
        putBits(7, 0);  super.close();  // obt@tbV
    }
}
