/**
* SBoyerMoo.java -- Boyer--Moore@
* @version $Revision: 1.1 $, $Date: 2003/03/20 03:05:51 $
*/
/* ȗBoyer-Moore@(String + charAt(i) )*/

import java.io.*;
/**
*ȗBoyer-Moore@ɂ镶ƍASỸvOłB
*@see KMP
*@see StringMatch
*/

public class BoyerMoore {
    static final int TABLE_SIZE = 255;
    /**
    *text ̒ pattern ̂ʒuT܂B
    *@param text eLXg
    *@param pattern ƍ
    *@return pattern ̂ʒuB擪 0B
    *pattern ꍇ〈Ȃꍇ -1 C
    *pattern ̒ 0 ̏ꍇ 0 Ԃ܂B
    */
    public static int position(String text, String pattern) {
        int[] skip = new int[TABLE_SIZE + 1];
        int len = pattern.length(); /* ̒ */

        if (len == 0) return -1;        /* G[: 0 */
        char tail = pattern.charAt(len - 1);        /* Ō̕ */
        if (len == 1) {                 /* 1ȂȒP! */
            for (int i = 0; i < text.length(); i++)
                if (text.charAt(i) == tail) return i;
        } else {                       /* 2ȏȂ\āc */
            int i;
            for (i = 0; i <= TABLE_SIZE; i++) skip[i] = len;
            for (i = 0; i < len - 1; i++)
                skip[pattern.charAt(i)] = len - 1 - i;
            /* i = len - 1; */          /* 悢ƍ */
            while (i < text.length()) {
                char c = text.charAt(i);
        /* fXg[Vp */
                System.out.print("e: " + text);
                System.out.print("\n: ");
                for (int j = i + 1 - len; j > 0; j--) System.out.print(" ");
                System.out.println(pattern);
        /**************************/
                if (c == tail) {
                    int j = len - 1, k = i;
                    while (pattern.charAt(--j) == text.charAt(--k))
                        if (j == 0) return k;  /*  */
                }
                i += skip[c];
            }
        }
        return -1;  /* Ȃ */
    }

    /*
    * len = 0 : eLXg̓́iȂ)
    * len > 0 : ƍ̓́B len ȉB
    */
    static String readInString(String s, int len) throws IOException {
        BufferedReader in =
            new BufferedReader(new InputStreamReader(System.in));

        if (len == 0) {
            String t = in.readLine();
            if (t.length() == 0) return s; // t 
            return t;
        }

        String t = in.readLine();
        if (t.length() > len) throw new Error("ƍ񂪒܂B");
        return t;
    }
    /**
    * <code>text = "supercalifragilisticexpialidocious"</code> ̏ꍇ
    *vOłB<br>
    *<strong>&quot;eLXg&quot;</strong><strong>&quot;ƍ&quot;</strong>
    *Ă܂͂ĂB<br>
    *ro߂\܂B
    */

    public static void main(String[] args) throws IOException {
        String text = "supercalifragilisticexpialidocious";
        String pattern = "";

        for ( ; ; ) {
            System.out.print("eLXg (Enter: " + text + ")\n  ? ");
            text = readInString(text, 0);
            System.out.print("ƍ (Enter: I)\n  ? ");
            pattern = readInString(pattern, text.length());
            if (pattern.length() == 0) break;
            int p = position(text, pattern);
            if (p >= 0) System.out.print("ʒu = " + p + "\n\n");
            else        System.out.print("܂.\n\n");
        }
    }
}
