/*
* Change.java -- K̕
* @version $Revision: 1.6 $, $Date: 2003/03/13 14:24:30 $
*/

/**
*K̕߂܂B
*@see NumberFormatter
*/

public class Change {
    /**
    *n ~ k ~ȉ̏KŎxʂ肠邩߂܂B<br>
    *ċAłłB
    */
    public static int howManyWays(int n, int k) {  // ċA
        if (n < 0) return 0;
        int s = 1 + n / 5 + howManyWays(n - 10, 10);
        if (k >=  50) s += howManyWays(n -  50,  50);
        if (k >= 100) s += howManyWays(n - 100, 100);
        return s;
    }
    /**
    *ċAłłB
    */
    public static int howManyWays1(int n) { // ċA
        int s = 0;

        for (int i = n / 100; i >= 0; i--) {    // 100~
            int t = n - 100 * i;
            for (int j = t / 50; j >= 0; j--) { //  50~
                int u = t - 50 * j;
                s += (1 + u / 5 - u / 10) * (1 + u / 10);
            }
        }
        return s;
    }
    /**
    *0 ` 500 ~KŎxʂ肠邩\܂B
    */
    public static void main(String[] args) {
        NumberFormatter fmt6d  = new NumberFormatter("6d"),
                        fmt10d = new NumberFormatter("10d");

        System.out.println("̕");
        System.out.println("  z    ċA  ċA");
        for (int i = 0; i <= 500; i += 5)
            System.out.println(fmt6d.toString(i) +
                fmt10d.toString(howManyWays(i, i)) + fmt10d.toString(howManyWays1(i)) );

    }
}
