/*
* CondNum.java -- 
* @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:31 $
* class RMatrix, LUMatInv, LU gB
*/

import java.io.*;

/**
* s̏߂܂B
* @see LUMatInv
* @see RMatrix
*/
public class CondNum {
    static double infinityNorm(double[][] a) { // m
        int n = a.length;
        double max = 0;
        for (int i = 0; i < n; i++) {
            double rowSum = 0;
            for (int j = 0; j < n; j++) rowSum += Math.abs(a[i][j]);
            if (rowSum > max) max = rowSum;
        }
        return max;
    }
    /**
    * s̏߂܂B
    * @param a ߂s <code>a[0..n-1][0..n-1]</code> ^܂B
    * @return s <code>a[][]</code> ̏Ԃ܂B
    */
    public static double getValue(double[][] a) { // 
        int n = a.length;
        double[][] aInv = new double[n][n];
        double t = infinityNorm(a);

        if (LUMatInv.inverse(a, aInv) == 0)  // mathutils.LUMatInv
            throw new Error("ts񂪂܂");
        return t * infinityNorm(aInv);
    }
    /**
    * geXgvOłB<br>
    * ŏɍs̎ n ͂܂B
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));

        System.out.print("s̎ n = ");
        int n = Integer.parseInt(in.readLine());    // s̎
        double[][] a = new double[n][n];

        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                a[i][j] = Math.random() - Math.random();

        RMatrix.print(a, 7, "10.6f");
        System.out.println(" = " + getValue(a));
    }
}
