/**
* ContFrac.java -- A
* @version $Revision: 1.3 $, $Date: 2002/12/16 01:03:22 $
*/
/**
* ÃvOłB
*/
public class ContFrac {
    /**
    * x PA<code>[b<sub>0</sub>,b<sub>1</sub>,b<sub>2</sub>,...b<sub>n</sub>]</code>
    *ɒ܂B
    */
    public static void simpleCF(double x, int n, long b[]) {
        b[0] = (long)Math.floor(x);
        for (int i = 1; i <= n; i++) {
            x = 1 / (x - b[i - 1]);
            b[i] = (long)Math.floor(x);
        }
    }
    private static long gcd(long x, long y) {
        while (y != 0) {
            long t = x % y;  x = y;  y = t;
        }
        return x;
    }
    /**
    * PA<code>[b<sub>0</sub>,b<sub>1</sub>,b<sub>2</sub>,...b<sub>n</sub>]</code>
    *𕁒ʂ̕ɒC\܂B
    */
    public static void reduceCF(int n, long b[]) {
        long f = b[n], g = 1;

        for (int i = n - 1; i >= 0; i--) {
            long temp = b[i] * f + g;  g = f;  f = temp;
            long d = gcd(f, g);  f /= d;  g /= d;
        }
        System.out.println(f + " / " + g + " = " + (double)f / g);
    }
    /**
    * eXgvOłB<br>
    * 1)Rΐ̒ e AWJ܂B<br>
    * 2)ꂽAӂ̕Ǝɒ܂B
    */
    public static void main(String[] args) {
        final int N = 20;
        long[] b = new long[N + 1];

        /* e = 2.718...̘AWJ */
        simpleCF(Math.E, N, b);
        System.out.print("e = [");
        for (int i = 0; i <= N; i++) System.out.print(b[i] + ",");
        System.out.println("...]");

        /* ӂ̕Ǝɒ */
        reduceCF(N, b);
        // Math.E \
        System.out.print("Math.E = " + Math.E);
    }
}
