/*
* GCD.java -- ő
* @version $Revision: 1.5 $, $Date: 2002/12/16 01:03:23 $
*/

import java.io.*;

/**
* ő񐔂߂܂B
* @see GCDandLCM
*/

public class GCD {
/**
* ċA
* @param x R
* @param y R
* @return <code>gcd(x,y)</code>
*/
    public static long gcdRec(long x, long y){
        if (y == 0) return x;
        else return gcdRec(y, x % y);
    }

/**
* ċA
*
* @param x R
* @param y R
* @return <code>gcd(x,y)</code>
*/
    public static long gcd(long x, long y) {
        while (y != 0) {
           long t = x % y;  x = y;  y = t;
        }
        return x;
    }
/**
* n ̎R a[0], ..., a[n-1] ̍ő񐔂߂܂B
* @return <code>gcd(a[0], ..., a[n-1])</code>
*/
    public static long ngcd(int n, long a[]){
        long d = a[0];

        for (int i = 1; i < n && d != 1; i++)
            d = gcd(a[i], d);
        return d;
    }
/**
* eXgpłB
* <b>u͂ĂiOŏIjBv</b>ƕĂ܂畡̐̐͂ĂB
*<b>0܂͕̐l</b>͂ƁCő񐔂\܂B<br>
*2̏ꍇ <code>gcdRec(a,b)</code>  <code>gcd(a,b)</code> Ăяo܂B2傫ꍇ
*<code>ngcd(n,a[])</code> Ăяo܂B
*/
    public static void main(String[] args) throws IOException {
        long a[] = new long[100];
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));

        System.out.println("͂ĂiOŏIjB");
        int i;
        for (i = 0; ; i++) {
            System.out.print("a["+ i +"]= ");
            long t;
            try { t = Long.parseLong(in.readLine());
            } catch(NumberFormatException e) { t = -1; }
            if (t < 1) break;
            a[i] = t;
        }
        if (i > 2) System.out.println("ő = " + ngcd(i, a));
        if (i == 2) {
            System.out.println("gcdRec("+ a[0] + "," + a[1] + ") = " + gcdRec(a[0], a[1]));
            System.out.println("gcd("+ a[0] + "," + a[1] + ") = " + gcd(a[0], a[1]));
        }
   }
}
