/*
* Gauss5.java -- 5dΊpȘA
* @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:32 $
* class RVector gB
*/
import java.io.*;

/**
* 5dΊpȘAꎟ Gauss @ŉ܂B
*@see GaussElimination
*@see Gauss3
*@see GaussSeidel
*/

public class Gauss5 {
    /**
    * Aꎟ Gauss @ŉ܂B
    */
    public static void solve(double[] diag, double[] sub1, double[] sub2,
            double[] sup1, double[] sup2, double[] b) {
        int n = diag.length;

        for (int i = 0; i < n - 2; i++) {  // @
            double t = sub1[i] / diag[i];
            diag[i + 1] -= t * sup1[i];
            sup1[i + 1] -= t * sup2[i];
            b   [i + 1] -= t * b   [i];
            t = sub2[i] / diag[i];
            sub1[i + 1] -= t * sup1[i];
            diag[i + 2] -= t * sup2[i];
            b   [i + 2] -= t * b   [i];
        }
        double t = sub1[n - 2] / diag[n - 2];
        diag[n - 1] -= t * sup1[n - 2];
        b   [n - 1] -= t * b   [n - 2];
        b[n - 1] /= diag[n - 1];       // ޑ
        b[n - 2] = (b[n - 2] - sup1[n - 2] * b[n - 1]) / diag[n - 2];
        for (int i = n - 3; i >= 0; i--)
            b[i] = (b[i] - sup1[i] * b[i + 1]
                    - sup2[i] * b[i + 2]) / diag[i];
    }
    /**
    * vOłB
    *<b>&quot;n =&quot;</b> ƕĂ܂ 3 ȏ̐l͂ĂB
    *\ׂ͂ 1.0 ɂȂ܂B
    */

    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        if (n < 3) System.exit(-1);

        double[] diag = new double[n], sub1 = new double[n],
                 sub2 = new double[n], sup1 = new double[n],
                 sup2 = new double[n], b    = new double[n];
        // .  ׂ͂ 1
        for (int i = 0; i < n; i++) {
            diag[i] = 11;  sub1[i] = 3;  sub2[i] = 1;
            sup1[i] =  4;  sup2[i] = 2;  b[i]    = 21;
        }
        b[0] = 17;  b[n - 1] = 15;
        b[1] -= 1;  b[n - 2] -= 2;
        solve(diag, sub1, sub2, sup1, sup2, b);
        RVector.print(b, 8, "9.6f");
        System.out.println("ׂ͂ 1");
    }
}
