import java.security.MessageDigest;
import java.io.FileInputStream;
import java.security.NoSuchAlgorithmException;
import java.io.IOException;

// MessageDigest  MD5 gTv
// java MD5  :  MD5 o͂
// java MD5 -f t@C : t@C MD5 o͂

class MD5 {
    // byte[]  16i̕ɕϊ
    static String convertByteToString(byte src[]) {
        String msg = "";
        for (int i = 0; i < src.length; i++) {
            int num = src[i] & 0xFF;
            if (num < 0x10) msg += "0";    // 1̏ꍇ0ǉ
            msg += Integer.toHexString(num);
        }
        return msg;
    }
    public static void main(String[] args) throws IOException, NoSuchAlgorithmException {
        boolean doReadFile = false;
        if (args.length == 2 && args[0].compareTo("-f") == 0) {
            doReadFile = true;
        } else if (args.length != 1) {
            System.err.println("usage: MD5 characters");
            System.err.println("usage: MD5 -f filename");
            return;
        }
        MessageDigest md5 = MessageDigest.getInstance("MD5");
        if (doReadFile) {
            FileInputStream file = new FileInputStream(args[1]);
            byte[] data = new byte[512];
            while (true) {
                int len = file.read(data);
                if (len < 0) break;
                md5.update(data, 0, len);
            }
            file.close();
        } else {
            md5.update(args[0].getBytes());
        }
        byte digest[] = md5.digest();
        System.out.println(convertByteToString(digest));
    }
}
