/*
* Newton2Test.java -- Newton@(Newton2)̎gp
* @version $Revision: 1.3 $, $Date: 2003/04/05 15:10:00 $
*/
/**
*Newton@(Newton2)̎gpłB
*/
import java.io.*;


public class Newton2Test {
    static class Function implements Newton2.Function {
        public double of(double x) { // _߂֐
            return x * (x * x - 1);
        }
    }
    /**
    * l͂ <code><i>x</i><sup>3</sup> - x = 0</code> ̉\܂B
    */
    public static void main(String[] args) throws IOException {
        BufferedReader input =
            new BufferedReader(new InputStreamReader(System.in));

        System.out.println("x^3 - x = 0 ܂.");
        System.out.print("l = ");
        double x0 = Double.parseDouble(input.readLine());

        Function f = new Function();
        double x = Newton2.solve(f, x0);

        System.out.println("x = " + x);
        System.out.println("f(x) = " + f.of(x));
    }
}
