/**
 * RadixConversion.java -- ̕ϊ
 * @version $Revision: 1.3 $, $Date: 2002/12/16 01:03:27 $
*/
import java.io.*;
import java.util.*;

/**
* Z(long l͈̔)̊̕ϊvOłB
*/

public class RadixConversion {
    // {ł͊ONXƂĂB
    static class IntArray {
    // (0 łȂ擪̌ʒu)ێ΂悢CGɂȂ邽߂ĂȂB
        int radix; // 
        int size;  // ő包
        int[] c;
        IntArray(int radix, int size) {
            this.radix = radix;   c = new int[this.size = size];
        }
        void init() { Arrays.fill(c, 0); } // 0 ŏ
    }

    static int longToArray(long x, IntArray y) {
        int i, d = y.radix;

        y.init();
        for (i = 0; x != 0 && i < y.size; i++) {
            y.c[i] = (int)(x % d);  x /= d;
        }
        if (x == 0) return i;   /*  */
        else        return -1;  /* G[ */
    }

    static int arrayToArray(IntArray src, IntArray dst) { // src ̓e͉󂳂
        dst.init();
        int i, ms = src.size, md = dst.size,
            rs = src.radix, rd = dst.radix;

        for (i = 0; ms > 0 && i < md; i++) {
            int r = 0;
            for (int j = ms - 1; j >= 0; j--) {
                int t = rs * r + src.c[j];   src.c[j] = t / rd;
                r = t % rd;
            }
            dst.c[i] = r;
            while (ms > 0 && src.c[ms - 1] == 0) ms--;
        }
        if (ms == 0) return i;   /*  */
        else         return -1;  /* G[ */
    }

    static long arrayToLong(IntArray x) { // di10i
        int m = x.size - 1;
        // ̂Qs͂ȂĂ悢
        while (m > 0 && x.c[m] == 0) m--; // 0 łȂ擪̌T
        if (m == 0) return 0; // SĂ̌ 0
        // y ɐ擪̌
        long y = x.c[m--], d = (long)x.radix;

        for ( ; m >= 0; m--) y = y * d + x.c[m]; // Horner @
        return y;
    }

    static final int M = 100;
    /**
    * vOłB<br>
    * <b>&quot;x = &quot;</b>ƕĂ܂C̐l long ͈͓̔(19ȓ)
    * ͂ĂB<br>
    * 8 iC2 iɕϊʂ\܂B
    */

    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("x = ");
        long x = Long.parseLong(in.readLine());
        IntArray x8 = new IntArray(8, M);
        IntArray x2 = new IntArray(2, M);
        int m1 = longToArray(x, x8);

        if (m1 < 0) {
            System.out.println("longToArray: error");  System.exit(-1);
        }

        System.out.print("8i(octal)   : ");
        for (int i = m1 - 1; i >= 0; i--) System.out.print(x8.c[i]);
        System.out.println();
        System.out.println("toOctalString: " + Long.toOctalString(x));

        int m2 = arrayToArray(x8, x2);
        if (m2 < 0) {
            System.out.println("arrayToArray: error");  System.exit(-1);
        }

        System.out.print("2i(binary)   : ");
        for (int i = m2 - 1; i >= 0; i--) System.out.print(x2.c[i]);
        System.out.println();
        System.out.println("toBinaryString: " + Long.toBinaryString(x));

        longToArray(x, x8); // arrayToArray()  x8 ̓e͉󂳂Ă邽ߍĕϊ
        System.out.println("8i10i: " + arrayToLong(x8));
        System.out.println("2i10i: " + arrayToLong(x2));
        System.out.println("2Ƃ͂lɖ߂͂B");
    }
}
