/**
* StemLeaf.java -- t\
* @version $Revision: 1.3 $, $Date: 2003/03/13 14:24:36 $
* InputDoubleData NXgB
*/
import java.io.*;
import java.util.*;

/**
* ^̃̕f[^t\vOłB
*@see InputDoubleData
*@see NumberFormatter
*/

public class StemLeaf {
    static final int MAX_LINES = 60;

    static void display(double[] x) {
        int kMin, kMax, n = x.length;
        int[] histo = new int[10 * MAX_LINES];
        double xMin = x[0], xMax = xMin, factor = 1;

        for (int i = 1; i < n; i++)
            if      (x[i] < xMin) xMin = x[i];
            else if (x[i] > xMax) xMax = x[i];
        while (factor * xMax > 32767 || factor * xMin < -32767)
            factor /= 10;
        for ( ; ; ) {
            kMin = (int)(factor * xMin) / 10 - ((xMin < 0) ? 1 : 0);
            kMax = (int)(factor * xMax) / 10;
            if (kMax - kMin + 1 <= MAX_LINES) break;
            factor /= 10;
        }
        System.out.println("10 *  + t = " + factor + " * f[^");
        for (int i = 0; i < n; i++)
            histo[(int)(factor * x[i]) - ((x[i] < 0) ? 1 : 0) - 10 * kMin]++;
        if (kMin < 0 && kMax > 0) {
            int k = 0;
            for (int i = 0; i < n; i++) if (x[i] == 0) k++;
            histo[-10 * kMin    ] -= k / 2;
            histo[-10 * kMin - 1] += k / 2;
        }
        NumberFormatter fmt5d = new NumberFormatter("5d");
        for (int k = kMin; k <= kMax; k++) {
            if (k != -1) System.out.print(fmt5d.toString(k + ((k < 0) ? 1 : 0)) + " | ");
            else         System.out.print("   -0 | ");
            for (int j = 0; j <= 9; j++) {
                int h;
                if (k >= 0) h = histo[10 * (k - kMin) + j];
                else h = histo[10 * (k - kMin) + 9 - j];
                for (int i = 0; i < h; i++) System.out.print(j);
            }
            System.out.println();
        }
    }
    /**
    *<b>f[^͂Ă</b> ƕĂ܂C<b>Enter</b>L[
    *؂ꂽ^f[^͂ĂBf[^̏Ił́C<b>Ctrl+z</b>
    *ĂB<br>
    *t\o͂܂B
    *<blockquote><pre>
    *<b>͗</b>i͂̕j
    *f[^͂Ă
    *<u><code>-3
    *5
    *6
    *12
    *12
    *15
    *23
    *^Z</code></u><br>
    *<b>o</b>
    *10 *  + t = 1.0 * f[^<code>
    *   -0 | 3
    *    0 | 56
    *    1 | 225
    *    2 | 3
    *</code></pre></blockquote>
    */

    public static void main(String[] args) throws IOException {
        System.err.println("f[^͂Ă");
        InputDoubleData data = new InputDoubleData();
        double[] x = data.getValue();

        display(x);
    }
}
