/**
 *  Ђt2
 *
 *  @version $Revision: 1.4 $, $Date: 2003/04/28 23:23:20 $
 */

import java.io.*;

public class ThreadedBinaryTree {
    class Node {  // ؂̃m[h
        Node left, right;  // E̎qւ̃|C^
        boolean isLeftThread, isRightThread;  // |C^Ђǂ
        String key;        // T̃L[io^j
        int count;         // QƉ񐔃JE^

        // Vm[h𐶐
        Node(String key, Node left, boolean isLeftThread,
                         Node right, boolean isRightThread) {
            this.key = key;  // L[Rs[
            count = 1;         // QƉ񐔂1ɂ
            this.left  = left;   this.isLeftThread =  isLeftThread;
            this.right = right;  this.isRightThread = isRightThread;
        }

        private void insertLeft(String key) {  // ̃m[h̍ɑ}
            Node q = new Node(key,        // Vm[h𐶐
                     left, isLeftThread,  // ̎q͐e̍̎q󂯌p
                     this, true);         // E̎q͐ewЂ
            left = q;                // {\tt q} eĩm[hj̍̎qɂ
            isLeftThread = false;    // {\tt q} ͂ЂłȂ
        }

        private void insertRight(String key) {  // ̃m[h̉Eɑ}
            Node q = new Node(key, this, true, right, isRightThread);
            right = q;  isRightThread = false;  //  {\tt insertLeft()} Q
        }

        private Node successor() {  // ł̒̃m[h
            // ${\tt right} \leftrightarrow {\tt left}$, ${\tt isRightThread} \leftrightarrow {\tt isLeftThread}$ ƂΒÕm[hɂȂ
            Node node = right;
            if (!isRightThread)
                while (!node.isLeftThread) node = node.left;
            return node;
        }
    }

    Node root;  // ؂̍

    ThreadedBinaryTree() {
        root = new Node(null, null, true, null, true);
        root.left = root.right = root;
    }

    public void insertNode(String key) {  // }(o^)
        Node node = root;
        int cmp = 1;  // rʁiŏ̎q͐ẻEɁj
        do {
            if (cmp < 0) {    // ΍ɓo^
                if (!node.isLeftThread) node = node.left;
                else {  node.insertLeft(key);  return;  }
            } else {          // 傫ΉEɓo^
                if (!node.isRightThread) node = node.right;
                else {  node.insertRight(key);  return;  }
            }
        } while ((cmp = key.compareTo(node.key)) != 0);
        node.count++;           // ΎQƉ񐔂𑝂
    }

    void printNode() {  // őSL[o
        Node node = root;
        while ((node = node.successor()) != root)
            System.out.println(node.key + " " + node.count);
    }

    public static void main(String[] args) throws IOException {
        StreamTokenizer input =
            new StreamTokenizer(new InputStreamReader(System.in));

        ThreadedBinaryTree tree = new ThreadedBinaryTree();
        while (input.nextToken() != input.TT_EOF)
            if (input.ttype == input.TT_WORD)  // W͂
                tree.insertNode(input.sval);  // Pǂݓo^
        tree.printNode();    // ePƏo񐔂ɏo
    }
}
