/**
* UTMult.java -- s̐
* @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:37 $
*/

/**
* Ops̐ςvZ܂B
* @see RMatrix
* @see MatMult
* @see OptMult
*/

public class UTMult {
    /**
    * Ops̐ a(n~n) = a(n~n) ~ b(n~n) vZ܂B<br>
    * a܂bsłȂꍇ̓G[I܂B
    * @param a s aCab㏑܂B
    * @param b s b
    */
    public static void getOnA(double[][] a, double[][] b) { /* Ops̐ */
        int n = a.length;

        if (n != a[0].length || n != b.length
                || n != b[0].length) throw new Error("ςvZł܂");

        for (int i = n - 1; i >= 0; i--)
            for (int j = n - 1; j >= i; j--) {
                double s = 0;
                for (int k = i; k <= j; k++) s += a[i][k] * b[k][j];
                a[i][j] = s;
            }
    }
    /**
    * gvOłB
    */
// eXgp : mathutils.RMatrix.java, MatMult.java gpB
    public static void main(String[] args) {
        final int N = 4;
        String fmt = new String("10.4f");
        double[][] a = new double[N][N];
        double[][] b = new double[N][N];
        double[][] c = new double[N][N];
        double[][] d = new double[N][N];

        for (int i = 0; i < N; i++)
            for (int j = i; j < N; j++) {
                d[i][j] = a[i][j] = 10 * Math.random();
                b[i][j] = 10 * Math.random();
            }
        double[][] rm = RMatrix.multiply(a, b);

        System.out.println("A");  RMatrix.print(a, N, fmt);
        System.out.println("B");  RMatrix.print(b, N, fmt);
        MatMult.getOnC(c, a, b);
        MatMult.getOnA(d, b);
        getOnA(a, b);
        System.out.println("AB by getOnA()");          RMatrix.print(a, N, fmt);
        System.out.println("AB by MatMult.getOnC()");  RMatrix.print(c, N, fmt);
        System.out.println("AB by MatMult.getOnA()");  RMatrix.print(d, N, fmt);
        System.out.println("AB by RMatrix.multiply()");  RMatrix.print(rm, N, fmt);
    }
}
